struct Font {
  int char_width, char_height, data_width;
  char *characters;
  byte *data;
};

class XC4607 {
public:
  unsigned int buffer[16];
  volatile bool vsync;
  XC4607();
  void tick();
  void wait_vsync();
  void cls();
  void set(int x, int y);
  void clr(int x, int y);
  void hline(int x, int y, int length);
  void vline(int x, int y, int length);
  void put(int x, int y, unsigned int data, int length);
  void blit8(int x, int y, byte *data, int width, int height, int stride = 1);
  void blit16(int x, int y, unsigned int *data, int width, int height, int stride = 1);
  void write(int x, int y, struct Font *font, char *text);
private:
  int row;
};
